﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Drawing.Imaging;

namespace Kresleni
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            PictureBox1_SizeChanged(null, null);

            Graphics g = Graphics.FromImage(pictureBox1.Image);
            Pen pen = new Pen(Color.FromArgb(255, 255, 0, 0));
            pen.Width = 5;
            g.DrawLine(pen, 0, 0, 100, 100);
            pictureBox1.Invalidate();
        }

        private void PictureBox1_SizeChanged(object sender, EventArgs e)
        {
            Bitmap old = null;
            if (pictureBox1.Image != null)
               old = new Bitmap (pictureBox1.Image);

            int w = pictureBox1.Width;
            int h = pictureBox1.Height;
            if (old != null)
            {
                if (old.Width > w) w = old.Width;
                if (old.Height > h) h = old.Height;
            }

            Bitmap b = new Bitmap (w, h);
            pictureBox1.Image = b;
            Graphics g = Graphics.FromImage(pictureBox1.Image);
            Brush brush = new SolidBrush(Color.White);
            g.FillRectangle(brush, 0, 0, w, h);

            if (old != null)
               g.DrawImage (old, 0, 0);

            pictureBox1.Invalidate();
        }

        private int X0, Y0;
        private bool press = false;
        private Image save;

        private void PictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            X0 = e.X;
            Y0 = e.Y;
            press = true;
            save = new Bitmap (pictureBox1.Image);
        }

        private void PictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            if (press)
            {
                Graphics g = Graphics.FromImage(pictureBox1.Image);
                g.DrawImage (save, 0, 0);
                Pen pen = new Pen(Color.FromArgb(255, 0, 255, 0));
                // g.DrawLine(pen, X0, Y0, e.X, e.Y);
                g.DrawRectangle (pen, X0, Y0, e.X-X0, e.Y-Y0);
                pictureBox1.Invalidate();
            }
        }

        private void PictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            Graphics g = Graphics.FromImage(pictureBox1.Image);
            Pen pen = new Pen(Color.FromArgb(255, 0, 0, 255));
            pen.Width = 3;
            // g.DrawLine (pen, X0, Y0, e.X, e.Y);
            g.DrawRectangle(pen, X0, Y0, e.X - X0, e.Y - Y0);
            pictureBox1.Invalidate();
            press = false;
        }
        private void OpenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                pictureBox1.Image = new Bitmap (openFileDialog1.FileName);
                PictureBox1_SizeChanged(null, null);
            }
        }

        private void SaveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // using System.Drawing.Imaging;
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                pictureBox1.Image.Save (saveFileDialog1.FileName, ImageFormat.Jpeg);
        }


        private void QuitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

    }
}
